/* Name: main.c
 * Author: <insert your name here>
 * Copyright: <insert your copyright message here>
 * License: <insert your license reference here>
 */

#include <avr/io.h>
#include <util/delay.h>

void chargeStatOne(uint8_t status)
{
    if (status)
    {
        DDRA = DDRA&0XF7; //turn PA3 into an input
    }
    else
    {
        DDRA = DDRA|0X08; //turn PA3 into an output shutting off Q1
    }
}

void chargeStatTwo(uint8_t status)
{
    if (status)
    {
        DDRA = DDRA&0XFE; //turn PA0 into an input
    }
    else
    {
        DDRA = DDRA|0X01; //turn PA0 into an output shutting off Q1
    }
}

void LEDStatTwo(uint8_t status)
{
    if (status)
    {
        PORTB = PORTB & 0XFD;
    }
    else
    {
        PORTB = PORTB | 0X02;
    }
}

void LEDStatOne(uint8_t status)
{
    if (status)
    {
        PORTB = PORTB & 0XFB;
    }
    else
    {
        PORTB = PORTB | 0X04;
    }
}

uint8_t buttonPushTwo()
{
    return (!(PINB&0X01));
}

uint8_t buttonPushOne()
{
    return (!(PINA&0X80));
}


uint8_t getCurrentOne()
{
    ADMUX = 0x82; //internal 1.1V ref. ADC2.
    ADCSRA = 0x87;//ADC enable, 1/128 prescaler
    ADCSRB = 0X10;//left justify result

    uint8_t ADCVal;
    ADCSRA|=0x40; //START CONVERSION
    while (ADCSRA&(0X40))
    {}
    ADCVal = ADCH;
    ADCSRA = 0X00;
    return ADCVal;

    
}

uint8_t getCurrentTwo()
{
    ADMUX = 0x81; //internal 1.1V ref. ADC1.
    ADCSRA = 0x87;//ADC enable, 1/128 prescaler
    ADCSRB = 0X10;//left justify result
    
    uint8_t ADCVal;
    ADCSRA|=0x40; //START CONVERSION
    while (ADCSRA&(0X40))
    {}
    ADCVal = ADCH;
    ADCSRA = 0X00;
    return ADCVal;
    
    
}

int main(void)
{
    PORTB = 0X07;//lift switch 2, raise LEDs
    DDRA = 0X00;
    DDRB = 0X06;//PB1 AND PB2 LEDS
    PORTA = 0x80;//lift switch 1
    
    chargeStatOne(0);
    chargeStatTwo(0);
    
    
    
    for (;;)
    {
        static uint8_t underCurrentCountOne = 0;
        static uint8_t underCurrentCountTwo = 0;

        //cut off at ADC=196 (1.1/256)*196 = .8434 = 1.4mA of current through 31ohm resistor +.8V
        uint8_t temp;
        temp = getCurrentOne();
        
        if (temp<=196)
        {
            underCurrentCountOne++;
            if (underCurrentCountOne>3)
            {
                chargeStatOne(0);//kill charge
                LEDStatOne(0);
            }
        }
        else
        {
            underCurrentCountOne=0;
        }
        
        temp=getCurrentTwo();
        if (temp<=196)
        {
            underCurrentCountTwo++;
            if (underCurrentCountTwo>3)
            {
                chargeStatTwo(0);//kill charge
                LEDStatTwo(0);
            }
        }
        else
        {
            underCurrentCountTwo=0;
        }
        _delay_ms(10);
        
        if (buttonPushOne())
        {
            LEDStatOne(1);
            chargeStatOne(1);
        }
        if (buttonPushTwo())
        {
            LEDStatTwo(1);
            chargeStatTwo(1);
        }
        
        
        
    }
	   
}


