/* Name: main.c
 * Author: <insert your name here>
 * Copyright: <insert your copyright message here>
 * License: <insert your license reference here>
 */

#include <avr/io.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include <avr/interrupt.h>  
#include <avr/sleep.h>
#include <avr/eeprom.h>
#include <avr/wdt.h>


uint8_t lightLevels[6]={0,1,30,1,0,0};

volatile uint8_t currentMainLight =0;
volatile uint8_t currentPWMLight=0;
volatile uint8_t delay=0;
volatile uint8_t ADCVal=200;

void lightOn(uint8_t light)
{
    PORTA = PORTA&0XF8;
    if (light!=6)
    {
      if (light<=1)
      {
          DDRA = 0X23;
          if (light==0)
              PORTA = PORTA |0x01;
          else
              PORTA = PORTA |0x02;
      }
      else if (light>=4)
      {
          DDRA = 0x25;
          if (light==5)
              PORTA = PORTA |0x01;
          else
              PORTA = PORTA |0x04;
      }
      else
      {
          DDRA = 0x26;
          if (light==3)
              PORTA = PORTA |0x02;
          else
              PORTA = PORTA |0X04;
          
      }
    }
  
}

int main(void)
{
    
    
	DDRA = 0X23;
    PORTA = 0X01;
    
    DDRB = 0x01;
    PORTB = 0X00;
    
    ACSR = 0x80;
    
    TIMSK0 = 0x01;//overflow interrupt
    TCCR0B = 0x03; //1/64 prescaler
    

    
    ADMUX = 0x21; //Vcc used as ref. measure 1.1V reference.
    ADCSRA = 0x87;//ADC enable, 1/256 prescaler
    ADCSRB = 0X10;//left justify result
    sei();
    
    ADCSRA|=0b01000000; //START CONVERSION
    for(;;)
    {
        if (ADCVal>90)
        {
          ADCSRA|=0b01000000; //START CONVERSION
          while (ADCSRA & (0b01000000))
          {}
          if (ADCH >90)
          {
            DDRB = DDRB & 0XFE;
            _delay_ms(100); //like tears...in rain...
            //there was a bug here where the thing would race back to sleep before it had a chance to die.
          }
        }
        //if it's done converting...
        if(!(ADCSRA & (0b01000000)))
        {
            ADCVal = ADCH;
            ADCSRA|=0b01000000; //START CONVERSION
        }
        
      
      
        else if (ADCVal<85)
        {
           DDRB = DDRB | 0X01;
           PORTB = PORTB & 0XFE;
        }
      
        uint8_t i;
        uint8_t j;
        
        
        if((PINB&0x02))
        {
            for (i=0;i<6;i++)
            {
                if (lightLevels[i])
                {
                    lightOn(i);
                    for (j=0;j<lightLevels[i];j++)
                        _delay_us(50);
                }
            }
          lightOn(6);
        }
      
        else
        {
            
            
          
            
            PORTA = PORTA & 0XF8;
            
            
            DDRA = 0X00;
            PORTA = 0X00;
            DDRB = 0X01;
            PORTB = 0X00;
            
            TIMSK0 = 0;//disable refresh timer
            TCNT1H = 0;
            TCNT1L = 0;
            
            ADCSRA = 0X00;
            PRR = 0x7;
          
            WDTCSR = 0x65; //watchdog timeout interrupt enable, watchdog enable, timeout after 1024K cycles
          
            MCUCR=0x90; //disable BOD, select power-down mode
          
            sleep_enable();
            sleep_cpu();
            sleep_disable();
          
            WDTCSR |= 0x18; //disable watchdog as specified in 8.5.2 of the datasheet
            WDTCSR &= 0xF7;
          
            PRR = 0x0;

            ADCSRA = 0x87;//ADC enable, 1/256 prescaler


            TIMSK0 = 1;//enable refresh timer
            _delay_ms(1);
            ADCSRA|=0b01000000; //START CONVERSION
            while (ADCSRA & (0b01000000))
            {}
            ADCVal=ADCH;

            DDRA = 0X23;
            PORTA = 0X00;
            
            DDRB = 0x01;
            PORTB = 0X00;

            
        }
    
    }
	    
}


ISR (TIM0_OVF_vect)
{
    if (delay)
    {
        uint8_t k;
        uint8_t temp = lightLevels[0];
        for(k=0;k<5;k++)
        {
            lightLevels[k]=lightLevels[k+1];
        }
        lightLevels[5]=temp;
        delay=0;
    }
    else
        delay++;
}

ISR(WATCHDOG_vect)
{
    //wakie wakie!
}
